<template>
  <delete-confirm
    :loading="loading"
    :show="show"
    @update:show="$emit('update:show', $event)"
    :name="name"
    type="item type"
    @remove="remove"
  />
</template>

<script lang="ts">
  import { Prop, Vue, Component } from 'vue-property-decorator';
  import { Repository } from '@/modals/itemType';

  @Component<ItemTypeDeleteDialog>({
    components: {
      DeleteConfirm: () => import('../DeleteConfirm.vue'),
    },
  })
  export default class ItemTypeDeleteDialog extends Vue {
    @Prop({
      type: Boolean,
      required: true,
    }) loading!: boolean;

    @Prop({
      type: Boolean,
      default: false,
    }) show!: boolean;

    @Prop({
      type: String,
      default: '',
    }) id!: string;

    @Prop({
      type: String,
      default: '',
    }) name!: string;

    remove() {
      if (!this.show) {
        return;
      }
      this.$emit('update:loading', true);
      return Repository.delete(this.id)
        .then(() => {
          this.$emit('update:show', false);
          this.$emit('update:loading', false);
          this.$emit('refresh');
        });
    }
  }
</script>
